## sddm 0.21.0

=== debian/changelog ===
sddm (0.21.0-1) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * New upstream release:
    - the D-Bus policy file is installed in /usr now (Closes: #1041237)
  * Update install files.
  * Remove the old /etc/dbus-1/system.d/sddm_org.freedesktop.DisplayManager.conf
    conffile.
  * Disable fixfilepath reproducibility feature, as it triggers build failures
    when enabled.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Switch the systemd build dependency to systemd-dev (Closes: #1060590);
    note that the libsystemd-dev build dependency is kept, as sddm uses
    libsystemd.
  * Bump Standards-Version to 4.7.0, no change required.
  * Drop the libupower-glib-dev build dependency, no more used.

  [ Atila KOÇ ]
  * Turkish debconf translation update. (Closes: #1032309)

 -- Pino Toscano <pino@debian.org>  Sun, 12 May 2024 12:05:56 +0200

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.4~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 1.4.0~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libxau-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               pkgconf,
               python3-docutils,
               qml-module-qttest <!nocheck>,
               qtbase5-dev (>= 5.15.0~),
               qtdeclarative5-dev (>= 5.15.0~),
               qttools5-dev,
               qttools5-dev-tools (>= 5.15.0~),
               systemd-dev [linux-any],
Standards-Version: 4.6.2
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/sddm
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/sddm.git
Rules-Requires-Root: no

Package: sddm
Architecture: any
Depends: adduser,
         qml-module-qtquick2,
         x11-common,
         xauth,
         xkb-data,
         xserver-xorg | xserver,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libpam-systemd, sddm-theme-debian-breeze | sddm-theme
Suggests: libpam-kwallet5, qtvirtualkeyboard-plugin
Provides: x-display-manager
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}
Breaks: sddm (<< ${source:Version})
Recommends: sddm
Provides: sddm-theme
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-maya
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maya' theme for SDDM X11 display manager
 Maya theme for SDDM

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

# Disable fixfilepath, as it causes build failures.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath

include /usr/share/dpkg/architecture.mk

SDDM_CMAKE_ARGS = -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/${DEB_HOST_MULTIARCH}/sddm \
	    -DSESSION_COMMAND="/etc/sddm/Xsession" \
	    -DWAYLAND_SESSION_COMMAND="/etc/sddm/wayland-session" \
	    -DBUILD_MAN_PAGES=ON \
	    -DDBUS_CONFIG_FILENAME="sddm_org.freedesktop.DisplayManager.conf"

ifneq ($(DEB_HOST_ARCH_OS),linux)
  SDDM_CMAKE_ARGS += -DNO_SYSTEMD=ON -DENABLE_JOURNALD=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- ${SDDM_CMAKE_ARGS}

override_dh_installsystemd:
	dh_installsystemd -psddm --no-start -r sddm.service

override_dh_installinit:
	dh_installinit --noscripts

execute_after_dh_auto_install:
	# not installed, as the Debian version is used instead
	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/sddm.service $(CURDIR)/debian/tmp/usr/lib/systemd/system/sddm.service

execute_after_dh_fixperms-arch:
	# ensure script is marked as executable
	chmod +x $(CURDIR)/debian/sddm/etc/sddm/Xsession

execute_after_dh_installpam:
	dh_installpam --name=sddm-autologin
	dh_installpam --name=sddm-greeter

## sddm 0.21.0%2Bgit20241213.4a9aa2e

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-qmldeps,
               cmake (>= 3.4~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libxau-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               login,
               pkgconf,
               python3-docutils,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick-window,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               systemd-dev [linux-any]
Standards-Version: 4.7.1
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Vcs-Git: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Rules-Requires-Root: no

Package: sddm
Architecture: any
Depends: adduser, ${misc:Depends}, ${qml6:Depends}, ${shlibs:Depends}
Recommends: libpam-systemd,
            qt6-virtualkeyboard-plugin,
            sddm-theme-debian-breeze | sddm-theme
Suggests: libpam-kwallet5
Breaks: sddm-theme-breeze (<< 4:6.0.0~)
Provides: x-display-manager
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Breaks: sddm (<< ${source:Version})
Recommends: sddm
Provides: sddm-theme
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-maya
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maya' theme for SDDM X11 display manager
 Maya theme for SDDM

=== debian/tests/control ===
Tests: main
Depends: @builddeps@
Restrictions: allow-stderr

## sddm 0.21.0+git20241213.4a9aa2e

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(SDDM)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Set version
set(SDDM_VERSION_MAJOR 0)
set(SDDM_VERSION_MINOR 21)
set(SDDM_VERSION_PATCH 0)
set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")
add_compile_definitions("SDDM_VERSION=\"${SDDM_VERSION_STRING}\"")

# Options
option(BUILD_MAN_PAGES "Build man pages" OFF)
option(ENABLE_JOURNALD "Enable logging to journald" ON)
option(NO_SYSTEMD "Disable systemd support" OFF)
option(USE_ELOGIND "Use elogind instead of logind" OFF)
option(BUILD_WITH_QT6 "Build with Qt 6" OFF)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")

# Definitions
add_definitions(-Wall -Wextra -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_FOREACH)

# Default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Handle build type
if(CMAKE_BUILD_TYPE MATCHES [Dd]ebug)
    message(STATUS "Debug build")
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0")
else()
    message(STATUS "Release build")
    add_definitions(-DNDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

# Default absolute paths
if(NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
    set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()
if(NOT DEFINED CMAKE_INSTALL_LOCALSTATEDIR)
    set(CMAKE_INSTALL_LOCALSTATEDIR "/var")
endif()

# Standard installation paths
include(GNUInstallDirs)

# Macros
include(FeatureSummary)

# PKG-CONFIG
find_package(PkgConfig)

# PAM
find_package(PAM REQUIRED)

# XAU
pkg_check_modules(LIBXAU REQUIRED "xau")

# XCB
find_package(XCB REQUIRED)

# XKB
find_package(XKB REQUIRED)

# Qt
if(BUILD_WITH_QT6)
    set(QT_MAJOR_VERSION 6)
    message(STATUS "Building Qt 6 version")
else()
    set(QT_MAJOR_VERSION 5)
    message(STATUS "Building Qt 5 version")
endif()

find_package(Qt${QT_MAJOR_VERSION} 5.15.0 CONFIG REQUIRED Core DBus Gui Qml Quick LinguistTools Test QuickTest)

# find qt5 imports dir
get_target_property(QMAKE_EXECUTABLE Qt${QT_MAJOR_VERSION}::qmake LOCATION)
if(NOT QT_IMPORTS_DIR)
    execute_process(COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

# systemd
if(NOT NO_SYSTEMD AND NOT USE_ELOGIND)
    pkg_check_modules(SYSTEMD "systemd")
endif()

if(SYSTEMD_FOUND)
    add_definitions(-DHAVE_SYSTEMD)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_SYSTEMD)

    # libsystemd-journal was merged into libsystemd in 209
    if(${SYSTEMD_VERSION} VERSION_LESS 209)
        pkg_check_modules(JOURNALD "libsystemd-journal")
    else()
        pkg_check_modules(JOURNALD "libsystemd")
    endif()

    if(ENABLE_JOURNALD)
        if(JOURNALD_FOUND)
            add_definitions(-DHAVE_JOURNALD)
            set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_JOURNALD)
        else()
            message(WARNING "Disable journald support for lack of libsystemd-journal")
        endif()
    endif()

    if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
        pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemdsystemunitdir)
    endif()

    if (NOT DEFINED SYSTEMD_SYSUSERS_DIR)
        pkg_get_variable(SYSTEMD_SYSUSERS_DIR systemd sysusersdir)
    endif()

    if (NOT DEFINED SYSTEMD_TMPFILES_DIR)
        pkg_get_variable(SYSTEMD_TMPFILES_DIR systemd tmpfilesdir)
    endif()

    set(HALT_COMMAND "/usr/bin/systemctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
else()
    set(SYSTEMD_FOUND 0)
endif()
add_feature_info("systemd" SYSTEMD_FOUND "systemd support")
add_feature_info("journald" JOURNALD_FOUND "journald support")

# elogind
if(NO_SYSTEMD AND USE_ELOGIND)
    pkg_check_modules(ELOGIND "libelogind")
endif()

if(ELOGIND_FOUND)
    add_definitions(-DHAVE_ELOGIND)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_ELOGIND)

    set(HALT_COMMAND "/usr/bin/loginctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/loginctl reboot")
endif()
add_feature_info("elogind" ELOGIND_FOUND "elogind support")

# Default behaviour if neither systemd nor elogind is used
if (NOT ELOGIND_FOUND AND NOT SYSTEMD_FOUND)
    # Set the VT on which sddm will normally appear, and the
    # commands for shutdown and reboot. On FreeBSD, there are
    # normally more getty's running than on Linux.
    if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
        set(HALT_COMMAND "/sbin/shutdown -p now")
    else()
        set(HALT_COMMAND "/sbin/shutdown -h -P now")
    endif()
    set(REBOOT_COMMAND "/sbin/shutdown -r now")
endif()

if (SYSTEMD_FOUND)
    set(RUNTIME_DIR_DEFAULT "/run/sddm")
else()
    set(RUNTIME_DIR_DEFAULT "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm")
endif()

# utmps
find_package(utmps)
add_feature_info("utmps" UTMPS_FOUND "utmps support")

# Set constants
set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/sddm"                CACHE PATH      "System application data install directory")
set(DBUS_CONFIG_DIR             "${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/system.d"       CACHE PATH      "DBus config files directory")
set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/sddm"      CACHE PATH      "State directory")
set(RUNTIME_DIR                 "${RUNTIME_DIR_DEFAULT}"                            CACHE PATH      "Runtime data storage directory")
set(QML_INSTALL_DIR             "${QT_IMPORTS_DIR}"                                 CACHE PATH      "QML component installation directory")

set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the X11 desktop session")
set(WAYLAND_SESSION_COMMAND     "${DATA_INSTALL_DIR}/scripts/wayland-session"       CACHE PATH      "Script to execute when starting the Wayland desktop session")

set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf"        CACHE PATH      "Path of the sddm config file")
set(CONFIG_DIR                  "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf.d"      CACHE PATH      "Path of the sddm config directory")
set(ACCOUNTSSERVICE_DATA_DIR    "/var/lib/AccountsService"                          CACHE PATH      "Path of the accountsservice data directory")
set(SYSTEM_CONFIG_DIR           "${CMAKE_INSTALL_PREFIX}/lib/sddm/sddm.conf.d"      CACHE PATH      "Path of the system sddm config directory")
set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/sddm.log"  CACHE PATH      "Path of the sddm log file")
set(DBUS_CONFIG_FILENAME        "org.freedesktop.DisplayManager.conf"               CACHE STRING    "Name of the sddm config file")
set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations-qt${QT_MAJOR_VERSION}" CACHE PATH      "Components translations directory")
set(SDDM_INITIAL_VT             "1"                                                 CACHE STRING    "Initial tty to use")


# Autodetect UID_MIN and UID_MAX from /etc/login.defs
if(NOT DEFINED LOGIN_DEFS_PATH)
    set(LOGIN_DEFS_PATH "/etc/login.defs" CACHE PATH "Path to login.defs")
endif()

if(NOT EXISTS "${LOGIN_DEFS_PATH}" AND NOT DEFINED UID_MIN AND NOT DEFINED UID_MAX)
    message(FATAL_ERROR "Could not find login.defs at ${LOGIN_DEFS_PATH}. Try -DLOGIN_DEFS_PATH.")
endif()

if(NOT DEFINED UID_MIN)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MIN LIMIT_COUNT 1 REGEX "^UID_MIN")
    string(REGEX REPLACE "^UID_MIN[\t ]+([0-9]+)" "\\1" UID_MIN "${UID_MIN}")
    if(NOT UID_MIN MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MIN (got '${UID_MIN}'). You should review your login.defs file.")
        set(UID_MIN 1000)
    else()
        message(STATUS "Autodetected UID_MIN=${UID_MIN} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

if(NOT DEFINED UID_MAX)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MAX LIMIT_COUNT 1 REGEX "^UID_MAX")
    string(REGEX REPLACE "^UID_MAX[\t ]+([0-9]+)" "\\1" UID_MAX "${UID_MAX}")
    if(NOT UID_MAX MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MAX (got '${UID_MAX}'). You should review your login.defs file.")
        set(UID_MAX 65000)
    else()
        message(STATUS "Autodetected UID_MAX=${UID_MAX} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

# Add subdirectories
add_subdirectory(components)
add_subdirectory(data)
add_subdirectory(services)
add_subdirectory(src)

enable_testing()
add_subdirectory(test)

# Display feature summary
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== services/CMakeLists.txt ===
if(SYSTEMD_FOUND)
    configure_file(sddm.service.in sddm.service)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm.service" DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")

    configure_file(sddm-sysuser.conf.in sddm-sysuser.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-sysuser.conf" DESTINATION "${SYSTEMD_SYSUSERS_DIR}" RENAME sddm.conf)
endif()

# systemd-tmpfiles can be used standalone without other systemd parts
if(DEFINED SYSTEMD_TMPFILES_DIR)
    configure_file(sddm-tmpfiles.conf.in sddm-tmpfiles.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-tmpfiles.conf" DESTINATION "${SYSTEMD_TMPFILES_DIR}" RENAME sddm.conf)
endif()

=== test/CMakeLists.txt ===
set(QT_USE_QTTEST TRUE)

include_directories(../src/common)

set(ConfigurationTest_SRCS ConfigurationTest.cpp ../src/common/ConfigReader.cpp)
add_executable(ConfigurationTest ${ConfigurationTest_SRCS})
add_test(NAME Configuration COMMAND ConfigurationTest)

target_link_libraries(ConfigurationTest Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Test)

set(QMLThemeConfigTest_SRCS QMLThemeConfigTest.cpp ../src/common/ThemeConfig.cpp ../src/common/ThemeConfig.h)
add_executable(QMLThemeConfigTest ${QMLThemeConfigTest_SRCS})
target_include_directories(QMLThemeConfigTest PRIVATE ../src/common/)
add_test(NAME QMLThemeConfig COMMAND QMLThemeConfigTest -platform offscreen -input ${CMAKE_CURRENT_SOURCE_DIR}/QMLThemeConfigTest.qml WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(QMLThemeConfigTest PRIVATE Qt${QT_MAJOR_VERSION}::Quick Qt${QT_MAJOR_VERSION}::QuickTest)

set(SessionTest_SRCS SessionTest.cpp ../src/common/Configuration.cpp ../src/common/ConfigReader.cpp ../src/common/Session.cpp)
add_executable(SessionTest ${SessionTest_SRCS})
target_include_directories(SessionTest PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/../src/common)
add_test(NAME Session COMMAND SessionTest)
target_link_libraries(SessionTest Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Test)

=== src/helper/CMakeLists.txt ===
include(CheckLibraryExists)

include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
    ${LIBXAU_INCLUDE_DIRS}
)
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(HELPER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    ${CMAKE_SOURCE_DIR}/src/common/XAuth.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
    Backend.cpp
    HelperApp.cpp
    UserSession.cpp
)

list(APPEND HELPER_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.cpp)

set(HELPER_SOURCES
    ${HELPER_SOURCES}
    backend/PamHandle.cpp
    backend/PamBackend.cpp
)

add_executable(sddm-helper ${HELPER_SOURCES})
target_link_libraries(sddm-helper
                      Qt${QT_MAJOR_VERSION}::Network
                      Qt${QT_MAJOR_VERSION}::DBus
                      Qt${QT_MAJOR_VERSION}::Qml
                      ${LIBXAU_LINK_LIBRARIES})
if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
    # On FreeBSD (possibly other BSDs as well), we want to use
    # setusercontext() to set up the login configuration from login.conf
    find_library(_have_libutil util)
    if(_have_libutil)
        check_library_exists(${_have_libutil} setusercontext "" _have_setusercontext)
    endif()
    if(_have_libutil AND _have_setusercontext)
        target_link_libraries(sddm-helper ${_have_libutil})
    endif()
endif()

if(PAM_FOUND)
    target_link_libraries(sddm-helper ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm-helper crypt)
endif()

if (UTMPS_FOUND)
    target_include_directories(sddm-helper SYSTEM PRIVATE ${UTMPS_INCLUDE_DIR})
    target_link_libraries(sddm-helper ${UTMPS_LIBRARIES})
endif (UTMPS_FOUND)

install(TARGETS sddm-helper RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(sddm-helper-start-wayland HelperStartWayland.cpp waylandsocketwatcher.cpp waylandhelper.cpp ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp)
target_link_libraries(sddm-helper-start-wayland Qt${QT_MAJOR_VERSION}::Core)
install(TARGETS sddm-helper-start-wayland RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(sddm-helper-start-x11user HelperStartX11User.cpp xorguserhelper.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/XAuth.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
                                                )
target_link_libraries(sddm-helper-start-x11user Qt${QT_MAJOR_VERSION}::Core
                                                ${LIBXAU_LINK_LIBRARIES})
install(TARGETS sddm-helper-start-x11user RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

if(JOURNALD_FOUND)
    target_link_libraries(sddm-helper ${JOURNALD_LIBRARIES})
    target_link_libraries(sddm-helper-start-x11user ${JOURNALD_LIBRARIES})
    target_link_libraries(sddm-helper-start-wayland ${JOURNALD_LIBRARIES})
endif()

=== debian/changelog ===
sddm (0.21.0+git20241213.4a9aa2e-1ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable, remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.
    - d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on arm64.
  * Refresh patches.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 24 Dec 2024 20:50:28 -0600

sddm (0.21.0+git20241213.4a9aa2e-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Sddm breaks sddm-theme-breeze versions earlier than 6.x.
  * New upstream git snapshot (0.21.0+git20241213.4a9aa2e). (Closes:
    #1089211, #1088277)
  * Refresh patches.
  * Upstream dropped its debian-specific PAM conf files that we were
    overriding anyway.
  * Add patch to make Maui theme’s background configurable.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 23 Dec 2024 18:54:29 +0100

sddm (0.21.0-6ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable, remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.
    - d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on arm64.
  * Use ${qml6:Depends} in binary package depends.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 14 Dec 2024 17:15:52 -0600

sddm (0.21.0-6) unstable; urgency=medium

  * Team upload.
  * Update the recommended virtual keyboard plugin to qt6-virtualkeyboard-plugin

 -- Salvo 'LtWorf' Tomaselli <ltworf@debian.org>  Sat, 14 Dec 2024 23:08:50 +0100

sddm (0.21.0-5) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 24 Nov 2024 23:10:36 +0100

sddm (0.21.0-4ubuntu4) plucky; urgency=medium

  * Drop depreciated qml6-module-qtqml-base depends.

 -- Rik Mills <rikmills@kde.org>  Mon, 09 Dec 2024 15:32:03 +0000

sddm (0.21.0-4ubuntu3) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.1.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 08 Dec 2024 18:11:32 -0600

sddm (0.21.0-4ubuntu2) plucky; urgency=medium

  * Revert the login -> login.defs build dependency change, this has not yet
    landed in Ubuntu.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 02 Nov 2024 22:14:35 -0500

sddm (0.21.0-4ubuntu1) plucky; urgency=medium

  * Merge from Debian Experimental, remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.
    - d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on arm64.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 02 Nov 2024 21:24:11 -0500

sddm (0.21.0-4) experimental; urgency=medium

  * Team upload.
  * Drop obsolete reference to example sddm.conf in README.Debian because
    upstream no longer provides a pregenerated example configuration (Closes:
    #911961, #1081684).
  * Add login.defs to Build-Depends because "login" is not part of
    build-essential in trixie, and because login might drop its login.defs
    dependency in forky.  Thanks to Santiago Vila and Chris Hofstaedtler
    (Closes: #1078320).

 -- Nicholas D Steeves <sten@debian.org>  Sun, 20 Oct 2024 20:48:44 -0400

sddm (0.21.0-3) experimental; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Move qtvirtualkeyboard-plugin from Suggests to Recommends for easier
    login on tablets.
  * Add missing QML dependencies.

 -- Patrick Franz <deltaone@debian.org>  Thu, 05 Sep 2024 18:24:07 +0200

sddm (0.21.0-2) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Build against Qt6.

 -- Aurélien COUDERC <coucouf@debian.org>  Fri, 12 Jul 2024 01:00:55 +0200

sddm (0.21.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-Depend on login so cmake can find and see the /etc/login.defs file.
    Just specifying it with -DLOGIN_DEFS_PATH is not enough. (Closes: #1078320)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 20 Oct 2024 19:52:26 +0200

sddm (0.21.0-1ubuntu4) oracular; urgency=medium

  * debian/patches: Drop revert_prefer-wayland-sessions-over-X11.patch

 -- Rik Mills <rikmills@kde.org>  Mon, 09 Sep 2024 06:48:11 +0100

sddm (0.21.0-1ubuntu3) oracular; urgency=medium

  * d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on
    arm64.

 -- Rik Mills <rikmills@kde.org>  Thu, 15 Aug 2024 10:11:52 +0100

sddm (0.21.0-1ubuntu2) oracular; urgency=medium

  [ Simon Quigley ]
  * Build with Qt 6 instead of Qt 5.

 -- Rik Mills <rikmills@kde.org>  Wed, 03 Jul 2024 09:53:36 -0500

sddm (0.21.0-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Revert upstream change prefering wayland sessions.


=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.4~),
               debhelper-compat (= 13),
               dh-sequence-qmldeps,
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libxau-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               login,
               pkgconf,
               python3-docutils,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick-window,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               systemd-dev [linux-any],
Standards-Version: 4.6.2
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Vcs-Git: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Rules-Requires-Root: no

Package: sddm
Architecture: any
Depends: adduser,
         x11-common,
         xauth,
         xkb-data,
         xserver-xorg | xserver,
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Recommends: libpam-systemd,
            qt6-virtualkeyboard-plugin,
            sddm-theme-debian-breeze | sddm-theme,
Suggests: libpam-kwallet5,
Breaks: sddm-theme-breeze (<< 4:6.0.0~),
Provides: x-display-manager,
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Breaks: sddm (<< ${source:Version}),
Recommends: sddm,
Provides: sddm-theme,
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-maya
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends}
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Maya' theme for SDDM X11 display manager
 Maya theme for SDDM

## sddm 0.21.0+git20250131.c2b97dd

=== data/themes/CMakeLists.txt ===
set(THEMES elarun maldives maya)

foreach(THEME ${THEMES})
    # We assume that theme-specific translations are stored
    # in ${THEME}/translations directory
    set(TRANSLATIONS_DIR "${THEME}/translations")
    file(GLOB TRANSLATION_SOURCES "${TRANSLATIONS_DIR}/*.ts")

    set_source_files_properties(${TRANSLATION_SOURCES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${TRANSLATIONS_DIR}")

    qt_add_translation(QM_FILES "${TRANSLATION_SOURCES}")

    configure_file("${THEME}/metadata.desktop.in" "${THEME}/metadata.desktop" @ONLY)

    install(DIRECTORY "${THEME}" DESTINATION "${DATA_INSTALL_DIR}/themes"
            PATTERN "${THEME}/*.in" EXCLUDE
            PATTERN "${THEME}/*.ts" EXCLUDE
            PATTERN "${THEME}/.gitattributes" EXCLUDE)

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${THEME}/metadata.desktop"
            DESTINATION "${DATA_INSTALL_DIR}/themes/${THEME}/")

    list(APPEND THEMES_QM_FILES ${QM_FILES})
endforeach(THEME)

add_custom_target(themes-translation DEPENDS ${THEMES_QM_FILES})

=== debian/changelog ===
sddm (0.21.0+git20250131.c2b97dd-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Mark SddmComponents as optional for dh_qmldeps to fix the arch:all
    build. (Closes: 1099481)

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 04 Mar 2025 07:38:00 +0100

sddm (0.21.0+git20250131.c2b97dd-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Rebuild for the qt6-declarative transition.
  * New upstream git snapshot with updated translations
    (0.21.0+git20250131.c2b97dd).
  * Bump Standards-Version to 4.7.2, no change required.
  * Switch to declarative KF6 debhelper build sequence.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 03 Mar 2025 08:37:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,18 @@
 Source: sddm
 Section: kde
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
 Build-Depends: cmake (>= 3.4~),
+               dh-sequence-qmldeps,
                debhelper-compat (= 13),
-               dh-sequence-qmldeps,
                libpam0g-dev,
                libsystemd-dev [linux-any],
                libxau-dev,
                libxcb-xkb-dev,
                libxcb1-dev,
                libxkbcommon-dev,
-               login,
+               login.defs,
                pkgconf,
                python3-docutils,
                qml6-module-qtqml-workerscript,
@@ -22,15 +21,16 @@
                qt6-declarative-dev,
                qt6-tools-dev,
                systemd-dev [linux-any],
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/sddm/sddm
-Vcs-Browser: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
-Vcs-Git: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/sddm
+Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/sddm.git
 Rules-Requires-Root: no
 
 Package: sddm
 Architecture: any
 Depends: adduser,
+         qml6-module-qtqml-workerscript,
          x11-common,
          xauth,
          xkb-data,
@@ -51,7 +51,9 @@
 
 Package: sddm-theme-debian-elarun
 Architecture: all
-Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
+Depends: desktop-base,
+         ${misc:Depends},
+         ${qml6:Depends},
 Recommends: sddm,
 Provides: sddm-theme,
 Breaks: sddm (<< ${source:Version}),
@@ -61,7 +63,9 @@
 
 Package: sddm-theme-debian-maui
 Architecture: all
-Depends: desktop-base, ${misc:Depends}, ${qml6:Depends}
+Depends: desktop-base,
+         ${misc:Depends},
+         ${qml6:Depends},
 Recommends: sddm,
 Provides: sddm-theme,
 Breaks: sddm (<< ${source:Version}),
@@ -71,7 +75,8 @@
 
 Package: sddm-theme-elarun
 Architecture: all
-Depends: ${misc:Depends}, ${qml6:Depends}
+Depends: ${misc:Depends},
+         ${qml6:Depends},
 Recommends: sddm,
 Provides: sddm-theme,
 Breaks: sddm (<< ${source:Version}),
@@ -80,7 +85,8 @@
 
 Package: sddm-theme-maldives
 Architecture: all
-Depends: ${misc:Depends}, ${qml6:Depends}
+Depends: ${misc:Depends},
+         ${qml6:Depends},
 Breaks: sddm (<< ${source:Version}),
 Recommends: sddm,
 Provides: sddm-theme,
@@ -89,7 +95,8 @@
 
 Package: sddm-theme-maui
 Architecture: all
-Depends: ${misc:Depends}, ${qml6:Depends}
+Depends: ${misc:Depends},
+         ${qml6:Depends},
 Recommends: sddm,
 Provides: sddm-theme,
 Breaks: sddm (<< ${source:Version}),
@@ -98,7 +105,8 @@
 
 Package: sddm-theme-maya
 Architecture: all
-Depends: ${misc:Depends}, ${qml6:Depends}
+Depends: ${misc:Depends},
+         ${qml6:Depends},
 Recommends: sddm,
 Provides: sddm-theme,
 Breaks: sddm (<< ${source:Version}),

## sddm 0.21.0+git20250502.4fe234b

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.5)
 
 project(SDDM)

=== data/man/CMakeLists.txt ===
find_program(RST2MAN_EXECUTABLE NAMES rst2man rst2man.py rst2man2 rst2man2.py)
if(NOT RST2MAN_EXECUTABLE)
    message(FATAL "rst2man (python-docutils) is required to build man pages")
endif()

function(BUILD_MAN_PAGE _sources _src _dst)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/${_src}"
                   IMMEDIATE @ONLY)

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_dst}"
                       COMMAND ${RST2MAN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/${_src}" "${CMAKE_CURRENT_BINARY_DIR}/${_dst}"
                       DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${_src}")

    list(APPEND "${_sources}" "${CMAKE_CURRENT_BINARY_DIR}/${_dst}")
    set("${_sources}" "${${_sources}}" PARENT_SCOPE)

    add_custom_target("man_${_src}" ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${_dst}")
endfunction()

build_man_page(MAN1_OUTPUT "sddm.rst" "sddm.1")
build_man_page(MAN1_OUTPUT "sddm-greeter.rst" "sddm-greeter.1")
build_man_page(MAN5_OUTPUT "sddm.conf.rst" "sddm.conf.5")
build_man_page(MAN5_OUTPUT "sddm-state.conf.rst" "sddm-state.conf.5")

install(FILES ${MAN1_OUTPUT} DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man1")
install(FILES ${MAN5_OUTPUT} DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man5")

=== data/translations/CMakeLists.txt ===
set(TRANSLATION_FILES
    ar.ts
    bg.ts
    bn.ts
    ca.ts
    cs.ts
    da.ts
    de.ts
    es.ts
    et.ts
    eu.ts
    fa.ts
    fi.ts
    fr.ts
    gl.ts
    hi_IN.ts
    he.ts
    hu.ts
    ie.ts
    is.ts
    it.ts
    ja.ts
    ka.ts
    kk.ts
    ko.ts
    lt.ts
    lv.ts
    nb.ts
    nl.ts
    nn.ts
    oc.ts
    pl.ts
    pt_BR.ts
    pt_PT.ts
    ro.ts
    ru.ts
    sk.ts
    sr.ts
    sr@ijekavian.ts
    sr@ijekavianlatin.ts
    sr@latin.ts
    sv.ts
    tr.ts
    uk.ts
    zh_CN.ts
    zh_TW.ts
)

qt_add_translation(QM_FILES ${TRANSLATION_FILES})

install(FILES ${QM_FILES} DESTINATION "${COMPONENTS_TRANSLATION_DIR}")

add_custom_target(components-translation DEPENDS ${QM_FILES})

=== debian/changelog ===
sddm (0.21.0+git20250502.4fe234b-2ubuntu2) resolute; urgency=medium

  * Drop xorg/x11 depends again.

 -- Rik Mills <rikmills@kde.org>  Mon, 03 Nov 2025 07:35:05 +0000

sddm (0.21.0+git20250502.4fe234b-2ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.
    - d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on arm64.

 -- Rik Mills <rikmills@kde.org>  Sat, 09 Aug 2025 12:13:25 +0100

sddm (0.21.0+git20250502.4fe234b-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Stop recommending qt6-virtualkeyboard-plugin, it makes non-
    virtualkeyboard aware themes unable to hide the virtual keyboard
    which causes issues for all SDDM themes but KDE’s breeze. Instead
    sddm-theme-breeze and sddm-theme-debian-breeze that can handle this
    correctly were added that recommends in plasma-desktop 4:6.3.6-1. (Closes:
    #1095604)

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 21 Jul 2025 08:57:40 +0200

sddm (0.21.0+git20250502.4fe234b-1ubuntu1) questing; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.
    - d/rules: Explicitly pass QML_INSTALL_DIR to cmake to fix FTBFS on arm64.

 -- Rik Mills <rikmills@kde.org>  Sun, 15 Jun 2025 09:20:49 +0100

sddm (0.21.0+git20250502.4fe234b-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream git snapshot (0.21.0+git20250502.4fe234b).
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 03 May 2025 20:32:40 +0200

sddm (0.21.0+git20241213.4a9aa2e-1ubuntu2) plucky; urgency=medium

  * Bump Standards-Version to 4.7.1, no changes needed.
  * Drop several Xorg Depends, these should be picked up elsewhere if truly
    needed.
  * Add a basic autopkgtest.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 21 Feb 2025 21:57:11 -0600

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-qmldeps,
               cmake (>= 3.5~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libxau-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               login,
               pkgconf,
               python3-docutils,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick-window,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               systemd-dev [linux-any],
Standards-Version: 4.7.2
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Vcs-Git: https://git.launchpad.net/~ubuntu-qt-code/+git/sddm
Rules-Requires-Root: no

Package: sddm
Architecture: any
Depends: adduser,
         qml6-module-qtqml-workerscript,
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Recommends: libpam-systemd,
            sddm-theme-debian-breeze | sddm-theme,
Suggests: libpam-kwallet5,
Breaks: sddm-theme-breeze (<< 4:6.0.0~),
Provides: x-display-manager,
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends},
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}, ${qml6:Depends},
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends},
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends},
Breaks: sddm (<< ${source:Version}),
Recommends: sddm,
Provides: sddm-theme,
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends},
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-maya
Architecture: all
Depends: ${misc:Depends}, ${qml6:Depends},
Recommends: sddm,
Provides: sddm-theme,
Breaks: sddm (<< ${source:Version}),
Description: 'Maya' theme for SDDM X11 display manager
 Maya theme for SDDM

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,9 @@
 	    -DSESSION_COMMAND="/etc/sddm/Xsession" \
 	    -DWAYLAND_SESSION_COMMAND="/etc/sddm/wayland-session" \
 	    -DBUILD_MAN_PAGES=ON \
-	    -DDBUS_CONFIG_FILENAME="sddm_org.freedesktop.DisplayManager.conf"
+	    -DDBUS_CONFIG_FILENAME="sddm_org.freedesktop.DisplayManager.conf" \
+	    -DBUILD_WITH_QT6=ON \
+	    -DQML_INSTALL_DIR=/usr/lib/${DEB_HOST_MULTIARCH}/qt6/qml
 
 ifneq ($(DEB_HOST_ARCH_OS),linux)
   SDDM_CMAKE_ARGS += -DNO_SYSTEMD=ON -DENABLE_JOURNALD=OFF
